<template>
    <div id="blog">
        <div class="posts-calendar-wrapper">
            <div style="width: 80%;">
                <el-row class="add-post-panel" v-if="user && user.isAdmin">
                    <div id="title-wrapper">
                        <el-input v-model="title" placeholder="Title" />
                    </div>
                    <editor api-key="czbdz7f9e00bb0btuqubcg5343htm55d9mapykzezxrza2x6" v-model="content" :init="{
                        menubar: false,
                        plugins: 'lists link image emoticons',
                        toolbar: 'styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist | link image emoticons'
                    }" />
                    <el-tooltip class="box-item" effect="dark" content="Add post" placement="top-start">
                        <el-button @click="addPost" style="margin: 10px;" type="success" :icon="Plus" circle />
                    </el-tooltip>
                </el-row>
                <el-divider content-position="left"></el-divider>
                <el-select v-if="postsDto.length!==0" class="filter-authors" v-model="userSelected" multiple placeholder="Filter authors"
                    style="width: 240px">
                    <el-option v-for="item in userSelection" :key="item.value" :label="item.label" :value="item.value" />
                </el-select>
                <ul class="posts-wrapper">
                    <li v-for="(post, index) in postsDto" :key="index">
                        <PostShort :title="post.title" :created="new Date(post.created)" :userEmail="post.userEmail" :id="post.id" />
                    </li>
                </ul>
                <br />
                <div v-if="postsDto.length===0" id="no-posts">There are no posts in the selected month</div>
            </div>
            <Calendar />
        </div>
        <el-backtop :right="10" :bottom="10" />
    </div>
</template>
<script setup lang="ts">
import { ref, Ref, onMounted, watch, getCurrentInstance } from 'vue';
import axios from 'axios';
import Editor from '@tinymce/tinymce-vue'

import { ElNotification } from 'element-plus';
import { Plus } from '@element-plus/icons-vue'

import useEmitter from '../composables/useEmitter';
import { useStore } from '../stores';
import { storeToRefs } from 'pinia';
import ShortPostDto from '../interfaces/ShortPostDto';
import User from '../interfaces/User';
import UserSelection from '../interfaces/UserSelection';
import PostShort from '../components/PostShort.vue';
import Calendar from '../components/Calendar.vue';


const emitter = useEmitter();
const store = useStore();
const { user } = storeToRefs(store)
const users: Ref<User[]> = ref([]);
const userSelection: Ref<UserSelection[]> = ref([]);
const userSelected: Ref<UserSelection> = ref({});
const postsDto: Ref<ShortPostDto[]> = ref([]);
const nonFilteredPostsDto: Ref<ShortPostDto[]> = ref([]);
const title: Ref<string> = ref('');
const content: Ref<string> = ref('');
const forceUpdate = ref(0);
const instance = getCurrentInstance();



onMounted(() => {
    getPosts();
});

emitter.on('getPosts', async ({ year, month, all }) => {
    getPosts(year, month);
})

watch(() => userSelected, (oldValue, newValue) => {
    getPosts();
}, {
    deep: true
});

function addPost() {
    if (title.value === '' || content.value === '') {
        handleEmptyTitleContent();
        return;
    }
    // @ts-ignore
    axios.post(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/post`,
        { title: title.value, content: content.value, uuid: user.value.uuid }).then(({ data }) => {
            console.log(data);
            title.value = '';
            content.value = '';
            getPosts();
        }).catch(err => {
            console.error(err);
        })
}
const dateNow = new Date()
function getPosts(year = dateNow.getFullYear(), month = dateNow.getMonth() + 1) {

    axios.get(
        // @ts-ignore
        `${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/post`, {
            params: {
                year, month
            }
    }
    )
        .then(async ({ data }) => {
            users.value = data;
            postsDto.value = [];
            let post;
            for (let i = 0, max = data.length; i < max; i++) {
                post = { id: data[i][0], created: data[i][1], title: data[i][2], userEmail: data[i][4] }
                postsDto.value.push(post);
            }

            userSelection.value = users.value.filter(user => user.admin).map(user => {
                return {
                    value: user.email,
                    label: user.email
                }
            });

            postsDto.value = postsDto.value.sort((a, b): number => {
                if (a < b) {
                    return 1;
                }
                if (a > b) {
                    return -1;
                }
                return 0;
            });

            // @ts-ignore
            if (userSelected.value.length !== 0) {
                postsDto.value = postsDto.value.filter(postDto => {
                    // @ts-ignore
                    return userSelected.value.indexOf(postDto.userEmail) >= 0;
                }
                )
            };
            // nonFilteredPostsDto.value = structuredClone(toRaw(postsDto.value));
            nonFilteredPostsDto.value = JSON.parse(JSON.stringify(postsDto.value));
            instance?.proxy?.$forceUpdate();
            forceUpdate.value += 1;
        })
        .catch((err) => {
            console.error(err);
        });



}

const handleEmptyTitleContent = () => {
    ElNotification({
        title: 'Error',
        message: 'Title and content cannot be empty',
        type: 'error',
    })
};

</script>
<style scoped lang="scss">
#blog {
    margin-top: 20px;

    .posts-calendar-wrapper {
        display: flex;
        flex-direction: row;
    }

    .add-post-panel {
        display: flex;
        justify-content: right;
        flex-direction: column;
        align-items: end;
    }

    #title-wrapper {
        margin: 10px auto;
        width: 100%;
    }

    .tox.tox-tinymce {
        width: 100%;
        margin-top: 14px;
    }

    .filter-authors {
        position: relative;
        left: 48px;
    }

    .posts-wrapper {
        list-style: none;
    }

    .tox {
        width: 100%;
        flex-basis: 100%;
    }

    #no-posts {
        display: flex;
        justify-content: center;
        align-items: center;
        margin-top: 48px;

    }
}
</style>
